import "std.zh"

const int CR_SWORDPART = 10; //The 'Script / Custom 4' counter.
const int I_HUNDRED_PIECE_SWORD = 123; //Custom item 1

const int HUNDRED_PIECE_SWORD_BASE_POWER = 1; //The minimum damage of the sword, before it is upgraded. 

//A pick-up/collect script. Attach to a sword piece item. 
//If you want ZC to display a screen string when the player picks it up, assign the ZQuest String ID
//to the D0 arg. 
//If you want a special message when the player collects ten pieces, assign that ZQuest
//string to the D1 arg.
//If you want this to play a special sound if the player picks up ten pieces, assign that Sound Effect
//ID to the D2 arg.
item script swordpart
{
	void run(int msg_id, int special_msg_id, int special_sfx)
	{
		++Game->Counter[CR_SWORDPART];
		itemdata sword = Game->LoadItemData(I_HUNDRED_PIECE_SWORD);
		sword->Power = Max(( Game->Counter[CR_SWORDPART] / 10 ),HUNDRED_PIECE_SWORD_BASE_POWER);
		
		
		if ( Game->Counter[CR_SWORDPART] % 10 || special_msg_id < 1 ) 
		{ 
			Screen->Message(msg_id); 
		}
		else 
		{ 
			Screen->Message(special_msg_id); 
			if ( Game->Counter[CR_SWORDPART] % 10 == 0 && special_sfx ) 
			{
				Game->PlaySound(special_sfx);
			}
		}
		
	}
}

//Assign this to global slot 4 ('onContinue')
//This re-applies the power modifications to the sword, every time that the player returns to 
//the game, after exiting. 
global script OnContinue
{
	void run()
	{
		itemdata sword = Game->LoadItemData(I_HUNDRED_PIECE_SWORD);
		sword->Power = Max(( Game->Counter[CR_SWORDPART] / 10 ), HUNDRED_PIECE_SWORD_BASE_POWER);
	}
}
	

//This is an ffc script to use as a special trigger. 
//To use it, place an ffc over the combo that you want to change, assign combo 1 to its 
//combo data field (combo 1 should be BLANK: Do not use Combo 0, as ffcs with
//combo 0 cannot run scripts. 
//Then, assign this script to the ffc. 
//Set the D0 arg to the minimum power that you wish the sword check to use. 
ffc script sword_power_trigger
{
	void run(int min_power)
	{
		lweapon l; int q;
		while(true)
		{
			for ( q = Screen->NumLWeapons(); q > 0; --q )
			{
				l = Screen->LoadLWeapon(q);
				if ( l->Damage >= min_power )
				{
					if ( Collision(l,this) )
					{
						//Advance the combo under the ffc by one, 
						++Screen->ComboD[ComboAt(this->X, this->Y)];
						//and clear any special flags
						Screen->ComboF[ComboAt(this->X, this->Y)] = 0;
						Screen->ComboI[ComboAt(this->X, this->Y)] = 0;
						Game->PlaySound(SFX_SECRET);
						Quit();
					}
				}
			}
			Waitframe();
		}
	}
}

ffc script a
{
	void run()
	{
		Trace(Game->Version);
		int tile = Game->ComboTile(10);
		int args[8] = { tile }; int ss[]="Args[0] is: ";
		TraceS(ss); Trace(args[0]);
		int sss[]="Args Index["; int ssss[]="] is: "; int buf[2];
		for ( int q = SizeOfArray(args)-1; q >= 0; --q ) 
		{
			itoa(buf,q);
			TraceS(sss); TraceS(buf); TraceS(ssss); Trace(args[q]);
		}
	}
}

//int aa[8] = {til};
int til = 10; //Game->ComboTile(11);

				
